<?php

class MessagesResource extends MailAdapter {	
	public function post($request){
		// to Receive POST Params (use $this->params)
 		parent::post($request);	
		
		if($this-> isLoggedIn()) 
		{					

			if($this->getParam('folderID') && $this->getParam('msgID') > 0) {
				$msg = $this->getMessage();
				if(!$msg){
					Errors::runException("MAIL_MESSAGE_NOT_FOUND", $this->getParam('folderID'));
				}
				else{
					$result = array ('messages' => array($msg));
					$this->setResult($result) ;
					return $this->getResponse();
				}
			}
	
			$max_email_per_page = intval($this->getParam('resultsPerPage') ? $this->getParam('resultsPerPage') :
					$this->getImap()->prefs['max_email_per_page']);
	
			$current_page = intval($this->getParam('page') ? $this->getParam('page') : 1);
	
			$msg_range_begin = ($max_email_per_page * ($current_page - 1)) + 1;
			$msg_range_end = $msg_range_begin + ($max_email_per_page  - 1);
	
			$this->getImap()->prefs['preview_msg_subject'] = "1";
	
	
			$imap_msgs = $this->getImap()-> get_range_msgs2(
					array(	"folder"			=> $this->getParam('folderID'),
							"msg_range_begin" 	=> $msg_range_begin,
							"msg_range_end"	 	=> $msg_range_end,
							"search_box_type"	=> "ALL",
							"sort_box_reverse"	=> "1",
							"sort_box_type"		=> "SORTARRIVAL"
					));
		}
		if(!$imap_msgs){
			return $this->getResponse();
		}
		
		$all_msgs = array();
	
		foreach($imap_msgs as $i => $imap_msg) {
			if(!is_int($i)) {
				continue;
			}
			$msg = array();
			$msg['msgID'] = $imap_msg['msg_number'];
			$msg['folderID'] =  $imap_msgs['folder'];
			$msg['msgDate']	= gmdate('d/m/Y H:i', $imap_msg['timestamp']);
			$msg['msgFrom']['fullName'] = $imap_msg['from']['name'];
			$msg['msgFrom']['mailAddress'] = $imap_msg['from']['email'];
			$msg['msgTo'][0]['fullName'] = $imap_msg['to']['name'];
			$msg['msgTo'][0]['mailAddress'] = $imap_msg['to']['email'];
			$msg['msgReplyTo'][0] = $this->formatMailObject($imap_msg['reply_toaddress']);
			$msg['msgSubject']  = mb_convert_encoding($imap_msg['subject'],"UTF8", "ISO_8859-1");
	
			$msg['msgHasAttachments'] = $imap_msg['attachment'] ? "1" : "0";
	
			$msg['msgFlagged'] 	= $imap_msg['Flagged'] == "F" ? "1" : "0";
			$msg['msgForwarded']= $imap_msg['Forwarded'] == "F" ? "1" : "0";
			$msg['msgAnswered'] = $imap_msg['Answered'] == "A" ? "1" : "0";
			$msg['msgDraft']	= $imap_msg['Draft'] == "X" ? "1" : "0";
			$msg['msgSeen'] 	= $imap_msg['Unseen'] == "U" ? "0" : "1";
	
			$msg['ContentType']	= $imap_msg['ContentType'];
			$msg['msgSize'] 	= $imap_msg['Size'];
	
			$msg['msgBodyResume'] = $imap_msg['msg_sample']['body'];
	
			if($this->getExpressoVersion() != "2.2") {
				$msg['msgBodyResume'] =  base64_decode($msg['msgBodyResume']);
			}
	
			$msg['msgBodyResume'] = substr($msg['msgBodyResume'], 2);
			$msg['msgBodyResume'] = str_replace("\r\n", "", $msg['msgBodyResume']);
			$msg['msgBodyResume'] = str_replace(chr(160)," ", $msg['msgBodyResume']);
			$msg['msgBodyResume'] = preg_replace('/\s\s+/', '', $msg['msgBodyResume']);
			$msg['msgBodyResume'] = mb_convert_encoding($msg['msgBodyResume'],"UTF8", "ISO_8859-1");
	
			$all_msgs[] = $msg;
		}
		$result = array (
				'messages' 	  => $all_msgs,
				'timeZone'	  => $imap_msgs['offsetToGMT'],
				'totalUnseen' => $imap_msgs['tot_unseen']
		);
			
		$this->setResult($result);	
		
		//	to Send Response (JSON RPC format)
		return $this->getResponse();		
	}
}